
#pragma once

#include "ShevArray.h"
#include "Vector3d.h"

namespace Shev
{
    class Polyhedron;
}

using namespace Shev;

//************************* 19.01.2006 ******************************//
//
//           .
//         .
//          (   dir )
//        point     
//      (     ).
//
//************************* 02.09.2010 ******************************//

Def<Line3d> getLine2 ( CArrRef<Vector3d> point );

Def<Line3d> getLine2 ( CArrRef<Vector3d> point, CArrRef<double> mass );

Def<Line3d> getLine2 ( CArrRef<Segment3d> segm );


//************************* 02.05.2013 ******************************//
//
//             
//             ( r )
//
//************************* 14.01.2018 ******************************//

Line3d getLineU ( CCArrRef<Vector3d> & data, double & r );


//************************* 19.01.2006 ******************************//
//
//           
//         
//
//************************* 29.09.2010 ******************************//

Plane3d getPlane2 ( CCArrRef<Vector3d> & point );

Plane3d getPlane2 ( CCArrRef<Vector3d> & point, CCArrRef<double> & mass );

Plane3d getPlane2 ( CCArrRef<Segment3d> & segm );


//************************ 05.02.2010 *******************************//
//
//             
//             ( r )
//
//************************ 09.12.2017 *******************************//

Plane3d getPlaneU ( CCArrRef<Vector3d> & point, double & r );

Plane3d getPlaneU ( CCArrRef<Vector3d> & point );


//************************ 23.06.2005 *******************************//
//
//                
//              Sum ( Ri^2 - R^2 )^2 -> min
//
//************************ 02.05.2010 *******************************//

Def<Sphere3d> getSpherePnt22 ( CArrRef<Vector3d> p );


//************************ 15.05.2010 *******************************//
//
//                
//                Sum ( Ri - R )^2 -> min
//
//************************ 15.05.2010 *******************************//

Def<Sphere3d> getSpherePnt2 ( CArrRef<Vector3d> p );


//************************ 15.05.2009 *******************************//
//
//            
//
//************************ 03.09.2010 *******************************//

Def<Sphere3d> getSpherePlg ( const Polyhedron & poly );


//************************ 28.11.2008 *******************************//
//
//            
//
//************************ 03.09.2010 *******************************//

Def<Ellipsoid3d> getEllipsoidPlg ( const Polyhedron & poly );


//************************ 15.05.2009 *******************************//
//
//        
//
//************************ 04.09.2010 *******************************//

Def<Cuboid3d> getCuboid ( const Polyhedron & poly );


//************************ 06.07.2023 *******************************//
//
//             
//                Z  .
//                 
//                  .
//
//************************ 06.07.2023 *******************************//

Def<Conform3d> minMaxPointsConvexPolyhedron1R ( CCArrRef<Vector3d> & point, const Polyhedron & poly );


//************************ 05.03.2023 *******************************//
//
//                
//                    ,  
//
//************************ 05.03.2023 *******************************//

Def<Vector3d> overlayConvexPolyhedronsNR ( const Polyhedron & poly1, const Polyhedron & poly2 );


//************************ 11.04.2008 *******************************//
//
//           
//          ( 1- )
//
//************************ 22.05.2010 *******************************//

Def<Vector3d> getNearPoint1 ( CArrRef<Plane3d> plane, nat & ix1, nat & ix2, nat & ix3 );
Def<Vector3d> getNearPoint1 ( CArrRef<Plane3d> plane );


//************************ 30.06.2013 *******************************//
//
//           
//       p- ( p = 4/3, 6/5, 8/7, 10/9 )
//
//************************ 30.06.2013 *******************************//

Def<Vector3d> getNearPoint4_3 ( CArrRef<Plane3d> plane );
Def<Vector3d> getNearPoint6_5 ( CArrRef<Plane3d> plane );
Def<Vector3d> getNearPoint8_7 ( CArrRef<Plane3d> plane );
Def<Vector3d> getNearPoint10_9( CArrRef<Plane3d> plane );


//************************ 29.01.2005 *******************************//
//
//           
//          ( 2- )
//
//************************ 22.05.2010 *******************************//

Def<Vector3d> getNearPoint2 ( CArrRef<Plane3d> plane );
Def<Vector3d> getNearPoint2 ( CArrRef<Plane3d> plane, CArrRef<double> mass );


//************************ 22.05.2010 *******************************//
//
//           
//         (   )
//
//************************ 22.05.2010 *******************************//

Def<Vector3d> getNearPointU ( CArrRef<Plane3d> plane );


//************************* 03.12.2016 ******************************//
//
//           
//       (mass)   0  1
//
//************************* 11.12.2019 ******************************//

Def<Vector3d> getNearPointR ( CCArrRef<Plane3d> & plane, ArrRef<double> & mass );


//************************ 03.02.2005 *******************************//
//
//           
//          ( 2- )
//
//************************ 13.09.2010 *******************************//

Def<Vector3d> getNearPoint2 ( CArrRef<Line3d> line );


//************************ 10.03.2012 *******************************//
//
//           
//         (   )
//
//************************ 10.03.2012 *******************************//

Def<Vector3d> getNearPointU ( CArrRef<Line3d> line );
