
#pragma once

#include "ShevArray.h"

class Cone3d;
class Spin3d;
class Plane3d;
class Vector3d;
class Sphere3d;
class Segment3d;
class Triangle3d;
class Cylinder3d;
class Ellipsoid3d;
class Rectangle3d;
class Cuboid3d;

namespace Shev
{
    class Facet;
    class Polyhedron;
}

using namespace Shev;

//**************************** 17.11.2012 *********************************//
//
//                             
//
//**************************** 17.11.2012 *********************************//

double volume ( const Sphere3d & fig ); //  

double volume ( const Ellipsoid3d & fig ); //  

double volume ( const Cuboid3d & fig ); //  

double volume ( const Cylinder3d & fig ); //  

double volume ( const Cone3d & fig ); //  

double volume ( const Polyhedron & fig ); //  


//**************************** 17.11.2012 *********************************//
//
//                         
//
//**************************** 12.06.2017 *********************************//

double getArea ( const Facet & facet, CArrRef<Vector3d> vert ); //   
double getArea ( const Polyhedron       & ); //   
double getArea ( const Triangle3d       & ); //      
double getArea ( const Sphere3d         & );
double getArea ( const Ellipsoid3d      & );
double getArea ( const Cuboid3d         & );
double getArea ( const Cylinder3d       & );
double getArea ( const Cone3d           & );


//**************************** 10.10.2009 *********************************//
//
//               
//
//**************************** 02.09.2010 *********************************//

Def<Segment3d> dimensions ( CArrRef<Vector3d> point );


//**************************** 08.01.2009 *********************************//
//
//               
//
//**************************** 08.01.2009 *********************************//

double diameterPnt ( CArrRef<Vector3d> point, const Vector3d & dir, nat & imin, nat & imax );

double diameterPnt ( CArrRef<Vector3d> point, const Vector3d & dir );


//**************************** 09.12.2017 *********************************//
//
//                  
//
//**************************** 09.12.2017 *********************************//

double diameterPnt ( CArrRef<Vector3d> point );


//**************************** 03.06.2017 *********************************//
//
//            
//
//**************************** 24.06.2017 *********************************//

double getDistance2 ( const Triangle3d & t, const Vector3d & p );


//**************************** 27.01.2018 *********************************//
//
//               
//
//**************************** 27.01.2018 *********************************//

double getDistance ( const Rectangle3d & r, const Vector3d & p );


//**************************** 15.08.2009 *********************************//
//
//        p   
//    a, b, c -    
//    d -   ( ,     )
//    r -      
//     false,    a, b, c  
//
//**************************** 15.08.2009 *********************************//

bool getDistanceEld ( double a, double b, double c, const Vector3d & p, double & d, Vector3d & r );


//****************** 28.08.2003 *******************************//
//
//          .
//      o -  , q -  .
//
//*************************************************************//

bool getSphere ( Vector3d a, Vector3d b, const Vector3d & c, Vector3d & o, double & q );


//****************** 28.08.2003 *******************************//
//
//          .
//      o -  , q -  .
//
//*************************************************************//

bool getSphere ( Vector3d a, Vector3d b, Vector3d c, const Vector3d & d, Vector3d & o, double & q );


//****************** 11.04.2010 *******************************//
//
//          
//          
//
//****************** 11.04.2010 *******************************//

Def<Sphere3d> spherePPPP ( const Plane3d & a, const Plane3d & b, const Plane3d & c, const Plane3d & d );


//****************** 23.01.2010 *******************************//
//
//          
//
//****************** 23.01.2010 *******************************//

Polyhedron & convexHull ( CCArrRef<Vector3d> & vert, Polyhedron & poly );


//****************** 20.11.2003 *******************************//
//
//         
//
//****************** 03.01.2011 *******************************//

DynArrRef<Plane3d> & convexHull ( CCArrRef<Vector3d> & point, DynArrRef<Plane3d> & plane );


//****************** 07.09.2021 *******************************//
//
//         
//
//****************** 07.09.2021 *******************************//

DynArrRef<Vector3d> & convexHull ( CCArrRef<Vector3d> & point, DynArrRef<Vector3d> & vert );


//****************** 04.11.2014 *******************************//
//
//        
//
//****************** 04.11.2014 *******************************//

Polyhedron & convexHull ( const Polyhedron & inner, Polyhedron & outer );


//****************** 21.08.2012 *******************************//
//
//         
//
//****************** 21.08.2012 *******************************//

bool isConvex ( const Polyhedron & poly );


//********************** 22.04.2018 ***************************//
//
//          
//
//********************** 22.04.2018 ***************************//

Spin3d makeSpin3d ( CCArrRef<Set2<Vector3d> > & data );


//********************** 04.05.2023 ***************************//
//
//               
//           
//
//********************** 04.05.2023 ***************************//

bool normalizePolyhedron ( ArrRef<Set2<DynArray<nat>, Plane3d> > & facet, ArrRef<Vector3d> & vertex );
