
#pragma once

#include "ShevArray.h"
#include "Vector3d.h"

namespace Shev
{
    class Polyhedron;
}

using namespace Shev;


//**************************** 28.08.2003 *********************************//
//
//                  
//
//**************************** 10.11.2010 *********************************//

Def<Sphere3d> minSphereAroundPoints ( CArrRef<Vector3d> data );


//**************************** 6.11.2010 *********************************//
//
//                  
//
//**************************** 16.11.2010 *********************************//

Def<Sphere3d> minSphereAroundSpheres ( CArrRef<Sphere3d> data );


//**************************** 17.04.2010 *********************************//
//
//           
//
//**************************** 17.04.2010 *********************************//

Def<Sphere3d> minSphere ( CArrRef<Plane3d> data );


//**************************** 07.03.2012 *********************************//
//
//           
//
//**************************** 07.03.2012 *********************************//

Def<Sphere3d> minSphere ( CArrRef<Line3d> data );


//**************************** 10.10.2009 *********************************//
//
//              
//
//**************************** 17.10.2009 *********************************//

Def<Ellipsoid3d> minEllipsoidV ( CArrRef<Vector3d> points );


//**************************** 02.05.2013 *********************************//
//
//            
//
//**************************** 02.05.2013 *********************************//

Def<Cylinder3d> minCylinderR ( CArrRef<Vector3d> data );


//**************************** 09.05.2016 *********************************//
//
//         
//
//**************************** 14.09.2019 *********************************//

bool minRegularTetrahedronAroundPointsNR ( CCArrRef<Vector3d> & data, const Ortho3d & ortho, Polyhedron & poly );


//**************************** 14.09.2019 *********************************//
//
//           
//
//**************************** 14.09.2019 *********************************//

bool minRegularTetrahedronAroundPoints ( CCArrRef<Vector3d> & data, Polyhedron & poly );


//**************************** 28.05.2016 *********************************//
//
//                 
//                  
//
//**************************** 28.05.2016 *********************************//

Def<Cuboid3d> minCuboidAroundPointsNR ( CArrRef<Vector3d> data );


//**************************** 11.02.2010 *********************************//
//
//              
//                
//
//**************************** 22.11.2010 *********************************//

Def<Cuboid3d> minCuboidAroundConvexPolyhedronV ( const Polyhedron & inner );


//**************************** 11.02.2010 *********************************//
//
//              
//                
//
//**************************** 23.11.2010 *********************************//

Def<Cuboid3d> minCuboidAroundConvexPolyhedronA ( const Polyhedron & inner );


//**************************** 09.03.2007 *********************************//
//
//               
//          dim -  
//          plane -     
//
//**************************** 16.11.2011 *********************************//

Def<Sphere3d> maxSphereInConvexPolyhedron ( const Segment3d & dim, CArrRef<const Plane3d *> plane, ArrRef<nat> index );
Def<Sphere3d> maxSphereInConvexPolyhedron ( const Segment3d & dim, CArrRef<const Plane3d *> plane );
Def<Sphere3d> maxSphereInConvexPolyhedron ( const Segment3d & dim, CArrRef<Plane3d> plane, ArrRef<nat> index );
Def<Sphere3d> maxSphereInConvexPolyhedron ( const Segment3d & dim, CArrRef<Plane3d> plane );
Def<Sphere3d> maxSphereInConvexPolyhedron ( const Polyhedron & poly );


//**************************** 08.08.2010 *********************************//
//
//          
//    ext -      
//
//**************************** 14.08.2010 *********************************//

Def<Cylinder3d> maxFixCylinderInConvexPolyhedron ( const Polyhedron & poly, double ext );


//**************************** 14.08.2010 *********************************//
//
//          
//    ext -      
//
//**************************** 14.08.2010 *********************************//

Def<Cone3d> maxFixConeInConvexPolyhedron ( const Polyhedron & poly, double ext );


//**************************** 18.08.2010 *********************************//
//
//        
//            
//    ext -    
//
//**************************** 18.08.2010 *********************************//

Def<Ellipsoid3d> maxFixSpheroidInConvexPolyhedron ( const Polyhedron & poly, double ext );


//**************************** 24.08.2012 *********************************//
//
//            
//
//**************************** 24.08.2012 *********************************//

Def<Cylinder3d> maxCylinderInConvexPolyhedronV ( const Polyhedron & poly );


//**************************** 24.08.2012 *********************************//
//
//            
//
//**************************** 24.08.2012 *********************************//

Def<Cone3d> maxConeInConvexPolyhedronV ( const Polyhedron & poly );


//**************************** 24.08.2012 *********************************//
//
//           
//
//**************************** 24.08.2012 *********************************//

Def<Ellipsoid3d> maxSpheroidInConvexPolyhedronV ( const Polyhedron & poly );


//**************************** 21.11.2013 *********************************//
//
//            
//
//**************************** 21.11.2013 *********************************//

Ellipsoid3d maxEllipsoidInTetrahedronV ( Vector3d v1, Vector3d v2, Vector3d v3, Vector3d v4 );


//**************************** 01.02.2017 *********************************//
//
//          
//
//**************************** 01.02.2017 *********************************//

Def<Ellipsoid3d> maxEllipsoidInConvexPolyhedronV ( const Polyhedron & poly );


//**************************** 05.02.2023 *********************************//
//
//               
//
//**************************** 05.02.2023 *********************************//

Def<Tetrahedron> maxTetrahedronInConvexPolyhedronV ( const Polyhedron & poly );


//**************************** 24.10.2021 *********************************//
//
//          
//             
//
//**************************** 24.10.2021 *********************************//

Def<Cuboid3d> maxCuboidInConvexPolyhedronNR ( const Polyhedron & poly, const Spin3d & spin = Spin3d() );


//**************************** 03.05.2014 *********************************//
//
//        
//
//**************************** 03.05.2014 *********************************//

Def<Conform3d> maxPolyhedronInConvexPolyhedronNR ( const Polyhedron & inner, const Polyhedron & outer );


//**************************** 30.03.2015 *********************************//
//
//           
//                   
//
//**************************** 30.03.2015 *********************************//

Def<Conform3d> maxPolyhedronInConvexPolyhedron1R ( const Polyhedron & inner, 
                                                   const Vector3d & az, nat sym,
                                                   const Polyhedron & outer );


//**************************** 31.07.2019 *********************************//
//
//           
//
//**************************** 31.07.2019 *********************************//

Def<Conform3d> maxPolyhedronInConvexPolyhedron ( const Polyhedron & inner, const Polyhedron & outer );